Ascending Rating(单调队列)

                                           Ascending Rating

                           Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 524288/524288 K (Java/Others)
                                                            Total Submission(s): 2702    Accepted Submission(s): 296

Problem Description

Before the start of contest, there are n ICPC contestants waiting in a long queue. They are labeled by 1 to n from left to right. It can be easily found that the i-th contestant's QodeForces rating is ai.
Little Q, the coach of Quailty Normal University, is bored to just watch them waiting in the queue. He starts to compare the rating of the contestants. He will pick a continous interval with length m, say [l,l+m−1], and then inspect each contestant from left to right. Initially, he will write down two numbers maxrating=−1 and count=0. Everytime he meets a contestant k with strictly higher rating than maxrating, he will change maxrating to ak and count to count+1.
Little T is also a coach waiting for the contest. He knows Little Q is not good at counting, so he is wondering what are the correct final value of maxrating and count. Please write a program to figure out the answer.

Input

The first line of the input contains an integer T(1≤T≤2000), denoting the number of test cases.
In each test case, there are 7 integers n,m,k,p,q,r,MOD(1≤m,k≤n≤107,5≤p,q,r,MOD≤109) in the first line, denoting the number of contestants, the length of interval, and the parameters k,p,q,r,MOD.
In the next line, there are k integers a1,a2,...,ak(0≤ai≤109), denoting the rating of the first k contestants.
To reduce the large input, we will use the following generator. The numbers p,q,r and MOD are given initially. The values ai(k<i≤n) are then produced as follows :

ai=(p×ai−1+q×i+r)modMOD

It is guaranteed that ∑n≤7×107 and ∑k≤2×106.

Output

Since the output file may be very large, let's denote maxratingi and counti as the result of interval [i,i+m−1] .
For each test case, you need to print a single line containing two integers A and B , where :

AB==∑i=1n−m+1(maxratingi⊕i)∑i=1n−m+1(counti⊕i)

Note that ``⊕ '' denotes binary XOR operation.

Sample Input

1
10 6 10 5 5 5 5
3 2 2 1 5 7 6 8 2 9

Sample Output

46 11

                                                             Statistic | Submit | Clarifications | Back

题意

  先给出一个长度为k(k<=n)的序列,和一个递推式,让你先求出整个长度为n的序列,然后对于每个区间都求题目给的式子,其中maxratingi为区间最大值,count为区间上升序列元素个数。对于不同的区间maxratingi和count要重新算。

解题思路

  递推区间的最大值可以用单调队列写,但是要反着想,这题的正解是反着用单调队列,维护一个递减的序列,对于每个区间的count就是队尾-队首的值。单调队列的最大值为队首

 注意在递推rep序列的时候,会爆int。

#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
int a[10000010],b[10000010],rep[10000010],c[10000010];//b记录最大,rep记录下标,c记录次数
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        int n,m,k,q,p,r,mod;
        scanf("%d%d%d%d%d%d%d",&n,&m,&k,&p,&q,&r,&mod);
        for(int i=1;i<=k;i++) scanf("%d",&a[i]);
        for(int i=k+1;i<=n;i++) a[i]=((ll)1*a[i-1]*p+(ll)1*q*i+r)%mod;//强制转化为ll 会爆int
        int head=1,tail=1;//head记录当前最大值的位置,tail记录符合单调的当前区间 即head是单调队列的首tail是单调队列的尾
        for(int i=n;i>=1;i--)
        {

            while(head<tail && a[rep[tail-1]]<=a[i]) tail--;//如果a[i]大于等于前面严格单调的说明前面操作存在不合法
            rep[tail++]=i;
            if(n-i+1>=m) //已经大于等于合法长度
            {

                b[i]=a[rep[head]];
                c[i]=tail-head;//得到合法单调长度
                if(rep[head]>=i+m-1)head++;//题目要求区间在[i,i-m+1] 不属于区间维护内的数要弹出
            }
        }

        ll A=0,B=0;
        for(int i=1;i<=n-m+1;i++)
        {

            A+=(b[i]^i);
            B+=(c[i]^i);

        }
        printf("%lld %lld\n",A,B);

    }

}

 

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值